
/**
 * Implementao de uma STACK de INTEIROS usando um ARRAY.
 * Notar que stk.length dar sempre o valor da dimenso 
 * definida para o ARRAY, no exemplo, 100.
 * 
 * @author Antnio Nestor Ribeiro 
 * @version 2006/03/27
 */
public class StackInt
{
	
  // v. de instncia

    private int[] stk;
    private int stkp;

  // Construtores
  
    public StackInt() {  // cria uma stack vazia !!
       this.stk = new int[100]; 
       this.stkp = 0;         // stkp indica a prxima posio onde inserir 
    }  

    public StackInt(int[] ai) {
       System.arraycopy(ai, 0, this.stk, 0, (ai.length > 100) ? 100: ai.length);
       this.stkp = ai.length;
    }

    
  // Mtodos de instncia

    public int size1() {  // comprimento do array != num. elementos da stack 
       return this.stk.length; 
    }

    public int size() {
       return this.stkp;
    }

    public void push(int e) { // necessria testar a pr-condio do tamanho max.
       this.stk[stkp] = e; 
       this.stkp++;
    }

   // pr-condio para push(int e)

    public boolean pre_push() {
      return (this.stkp > 99) ? false: true;
    } 

   // pr-condio para pop() e para top()

   public boolean empty() {
       return this.stkp == 0;
    }

   public int top() {  // a usar se stack  garantidamente no vazia
       return this.stk[this.stkp-1];
   }
       
   public void pop1() { // testa se stack  no vazia. 
			// Se for, no faz pop mas tambm no d "feedback" !!
       if (this.stkp > 0) this.stkp--;
   }

   public void pop() { // pop() total !! admite que a pr-condio foi testada.
       stkp--;
   }  

   public int[] listStack() { // Devolve uma cpia do array. No entanto 
                              // j mostra muito do estado interno
      int[] stkCopy = new int[this.size()];
      System.arraycopy(this.stk, 0, stkCopy, 0, this.size());
      return stkCopy;
   }


   public String toString() { // Usa StringBuffer. 
      StringBuffer s = new StringBuffer();
      for(int i=0; i<= this.size(); i++) {
         s.append(this.stk[i]); s.append("\nl");
      }
      return s.toString(); // converte StringBuffer para String
   }
     

}
